#!/bin/bash
#
# pop-up calendar for dzen
#
# based on (c) 2007, by Robert Manea
# http://dzen.geekmode.org/dwiki/doku.php?id=dzen:calendar
# modified by urukrama
# modified by calimero (december debug, autoadjust)
# modified by wisthler (adding spaces at the last line)

corrige(){
    CMD=$*
    for((i = 0; i <= 2; i+=1))
    do
        LIGNE=`$CMD | tail -n $i | head -n 1`
        COUNT=`echo $LIGNE | wc -m`
        if [ "$COUNT" == "3" ]; then
            break
        fi            
    done
    CORRECT=$LIGNE
    MAX=22
    for((i = $COUNT; i < MAX-1; i+=1))
    do
        CORRECT=`echo "$CORRECT "`
    done
    echo "s/$LIGNE/$CORRECT/"
}



xres="$(xrandr |head -n1 |awk {'print $8'} |sed 's/,//')"
yres="$(xrandr |head -n1 |awk {'print $10'} |sed 's/,//')"

TODAY=$(expr `date +'%d'` + 0)
MONTH=`date +'%m'`
YEAR=`date +'%Y'`

(
echo '^bg(#dbdbdb)^fg(#000000)'`date +'%A %d %B %Y %n'`; echo
\
# current month, hilight header and today

CMDCAL="cal"
EDIT=`corrige "$CMDCAL"`

$CMDCAL | sed "$EDIT"  \
    | sed -re "s/^(.*[A-Za-z][A-Za-z]*.*)$/^fg(#111111)^bg(#c6c6c6)\1/;s/(^|[ ])($TODAY)($|[ ])/\1^bg(#3488de)^fg(#dbdbdb)\2^fg(#6c6c6c)^bg(#dbdbdb)\3/"

# next month, hilight header
[ $MONTH -eq 12 ] && YEAR=`expr $YEAR + 1`
monthp=`expr \( $MONTH + 1 \) % 13`
[ $monthp -eq 0 ] && monthp=1

CMDCAL="cal $monthp $YEAR"
EDIT=`corrige "$CMDCAL"`

$CMDCAL | sed "$EDIT" |sed -e 's/^\(.*[A-Za-z][A-Za-z]*.*\)$/^fg(#111111)^bg(#c6c6c6)\1/'


sleep 5
) \
    | dzen2 -fg '#6c6c6c' -bg '#dbdbdb' -fn '-*-fixed-*-*-*-*-12-*-*-*-*-*-*-*' -x $[$xres-165] -y $[$yres-37] -w 164 -l 18 -sa c -e 'onstart=uncollapse;key_Escape=ungrabkeys,exit'
